// updated for 11.3 DP5

@import Foundation;
#import "Utils/Trace.m"
#import "Utils/Swizzling.m"

@interface Fake:NSObject
@end

@implementation Fake

// prevent sealing
-(BOOL)fake_doNotSealSystem
{
	trace(@"doNotSealSystem");
	return true;
}

// force old codepath even on a Big Sur system
// TODO: sort of a hack, we should just figure out how to
// bypass the checks in the update brain
-(BOOL)fake_isLegacyMSUSpringboard
{
	trace(@"isLegacyMSUSpringboard");
	return true;
}

// compatibility
-(bool)fake__queue_isDeviceSupported:(id)rdx
{
	trace(@"_queue_isDeviceSupported:");
	return true;
}

// ignore lack of APFS boot ROM support
+(BOOL)fake_apfsSupportedByROM
{
	trace(@"apfsSupportedByROM");
	return true;
}

@end

@interface Inject:NSObject
@end

@implementation Inject

+(void)load
{
	traceSetPrefix(@"Hax6: ");
	traceSetLog(true);
	
	NSString* processName=NSProcessInfo.processInfo.processName;
	
	if([processName containsString:@"osinstallersetupd"])
	{
		trace(@"loading hacks for osinstallersetupd");
		
		swizzleSimplePrinting(@"OSISCustomizationController",@"doNotSealSystem",true);
		swizzleSimplePrinting(@"OSISCustomizationController",@"isLegacyMSUSpringboard",true);
		swizzleSimplePrinting(@"BIBuildInformation",@"_queue_isDeviceSupported:",true);
		swizzleSimplePrinting(@"OSISUtilities",@"apfsSupportedByROM",false);
	}
}

@end